# Copyright 2015 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

require 'google/apis/identitytoolkit_v3/service.rb'
require 'google/apis/identitytoolkit_v3/classes.rb'
require 'google/apis/identitytoolkit_v3/representations.rb'

module Google
  module Apis
    # Google Identity Toolkit API
    #
    # Help the third party sites to implement federated login.
    #
    # @see https://developers.google.com/identity-toolkit/v3/
    module IdentitytoolkitV3
      VERSION = 'V3'
      REVISION = '20170927'

      # View and manage your data across Google Cloud Platform services
      AUTH_CLOUD_PLATFORM = 'https://www.googleapis.com/auth/cloud-platform'

      # View and administer all your Firebase data and settings
      AUTH_FIREBASE = 'https://www.googleapis.com/auth/firebase'
    end
  end
end
